#define _POSIX_C_SOURCE 1
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>

#define BUF_SIZE 8192

#include "jsocket.h"
#include "util.h"

/*
 * Servidor cat-remoto
 */

void conexion(int s2) {
  char* path = getstr(s2);
  int n;
  FILE *in, *out;
  char buf[BUF_SIZE];
  out= fdopen(s2, "w");
  if ((in= fopen(path, "r")) != NULL){
    while((n=fread(buf, 1, BUF_SIZE, in)) > 0)
      fwrite(buf, 1, n, out);
    fclose(in);
  }
  fclose(out);
  free(path);
}

/*
 * Esta es la forma mas simple de enterrar a los hijos sin complicarse la vida
 */
void child() {
  int status;
  while (waitpid(-1, &status, WNOHANG)>0)
    ;
  signal(SIGCHLD, child);
}

int main (int argc, char** argv){
  int s;
  if(argc != 2){
    fprintf(stderr, "error en el numero de argumentos\n");
    exit(1);
  } 
  signal(SIGCHLD, child);
  s = j_socket();
  if(j_bind(s, atoi(argv[1])) < 0) {
    perror("bind");
    exit(2);
  }
  for (;;) {
    int s2 = j_accept(s);
    if (s2>0) {
      int pid= fork();
      if (pid==0) {
        conexion(s2);
        exit(0);
      }
      else {
        close(s2);
      }
    }
    else if (errno!=EINTR) {
      perror("accept");
      break;
    }
  }
  return 1;
}
